import{csv, json, timeParse} from 'd3';
import { feature } from 'topojson';

export const parseYear = timeParse('%Y');

export const loadAndProcessData = () => 
  Promise
    .all([
      csv('https://vizhub.com/jons288/datasets/travelers.csv'),
      json('https://gist.githubusercontent.com/mbostock/4090846/raw/d534aba169207548a8a3d670c9c2cc719ff05c47/us.json')
    ])
    .then(([csvData, topoJSONdata]) => {
      
      var date_sort_asc = function (date1, date2) {
        if (date1 > date2) return 1;
        if (date1 < date2) return -1;
        return 0;
      };
      const allDates = csvData.map(d=>d.Date)
      let dates = Array.from(new Set(allDates))

      
      dates.sort((a,b)=>(new Date(a) - new Date(b)))
    
        
      const part = 7
      const daySales = csvData.filter(d => d.Date ===dates[part])
      
      const rowById = daySales.reduce((accumulator, d) => {
        accumulator[d['id']] = d;
        return accumulator;
         
      }, {});
       
      const states = feature(topoJSONdata, topoJSONdata.objects.states);
    
      states.features.forEach(d => { 
        Object.assign(d.properties,rowById[d.id]);
      });
      states.features.pop()
      states.features.pop()
      return [states,dates];   
      
    }); 